
'// Smoke
Global CopChance:Int = 2

Type tFakeCar
	Const Acceleration:Float = 00.05
	Const TopSpeed:Float = 1'05.0
	Const TurnAcceleration#	= 01.0
	Const TurnMax# 		= 7'10.0
	Const MaxPoints#		= 50.0
	Const MissileSpeed:Int = 2'2
		
	

	Field x:Float, y:Float
	Field DirectionX#,DirectionY#
	Field XS#,YS#
	Field Done:Int
	Field Degree#
	Field Direction#
	Field TurnSpeed:Float
	Field img:Int
	Field pMap:TPixmap
	Field Damage:Int = 0
	Field emitter:ParticleEmitter
	Field smoker:tsmoker

	Method Draw()
		SetOrigin offX, offY
		SetColor 0, 0, 0
		SetAlpha 0.5
		SetRotation Direction + 90
		DrawImage CarImg, x + 1, y + 1, img
		If Damage > 100 Then
			SetColor 32, 32, 32
		Else
			SetColor 255, 255, 255
		EndIf
		
		SetAlpha 1
		DrawImage(CarImg, x, y, img)
		
		SetRotation 0
		SetAlpha 1
		
		If smoker Then
			smoker.Update(x, y)
			smoker.Draw
		EndIf
		
		
		
		
		SetOrigin 0, 0
	End Method
	
	Method Update_Collision()
		Local tx:Int, ty:Int
		Local c:Int
		'Local p:Byte Ptr = Varptr c
		tx = (Int(x) / 64) '/ tRoadMap.W
		ty = (Int(y) / 64) '/ tRoadMap.H
		If RoadMapImg[tx, ty] Then
			pMap = RoadMapImg[tx, ty].pixmaps[0]
			'
		Else
			'do game ending explotion!
			Carslist.Remove(Self)
			Print "Cop oob!"
			Return
			'RuntimeError("Cheats!")
		EndIf
		Assert pMap <> Null
		
		c = pMap.ReadPixel(Int(x) Mod 64, Int(y) Mod 64)
		'Print Hex(c)
		If c = $FFB97A57 Then
			Bump()
			'UpdatePhysics
		ElseIf c = $FFFFFFFF Then
			Slow()
		EndIf
		
		For Local oc:tFakeCar = EachIn Carslist
			If oc <> Self Then
				If Dist(oc.x, oc.y, x, y) < 8 Then
					Bump()
				EndIf
			EndIf
		Next
		
		If Dist(Player.positionX, Player.positionY, x, y) < 8 Then
			
			
			If Max(Abs(Player.velocityX), Abs(Player.velocityY)) > 0.5 Or Max(Abs(XS), Abs(YS)) > 0.4 And Damage < 100 Then
				Bump()
				Player.Damage:+2
				
				bexplo = True
				
				Player.velocityX = -(Player.velocityX / 1)
				Player.velocityY = -(Player.velocityY / 1)
				Player.UpdatePhysics
				
			EndIf
			    'Max(Abs(Player.velocityX), Abs(Player.velocityY)) + Max(Abs(XS), Abs(YS))
			
		EndIf
		
		If Timer Mod 3 = 0 Then
		For Local p:tPed = EachIn pedelist
			 p.Update(x, y)
		Next
		EndIf
		
		
		If Damage > 50 And emitter = Null Then
			If Not smoker Then smoker = tSmoker.Create(x, y)
			'emitter = ParticleEmitter.Create(CurrentDir() + "/img/smk1.txt")
		EndIf
		
	End Method
	
	Method Slow()
		XS:*0.9
		YS:*0.9
	End Method
	
	Method Bump()
		XS = -(XS / 1)
		YS = -(YS / 1)
		Damage:+5
	'	bexplo = True
	End Method
	
	
	Method Update:Int(nx:Int, ny:Int)
		If Dist(x, y, Player.positionX, Player.positionY) > 64 * 4 Then
			Carslist.Remove(Self)
			Return 0
		EndIf
		
		If Damage > 100 Then
			XS = 0
			YS = 0
			Return 0
		EndIf
	
		XS:+ Cos(Direction)*Acceleration
		YS:+ Sin(Direction)*Acceleration
		
		Local CurrentSpeed# = Sqr(XS*XS + YS*YS)
		
		If CurrentSpeed > TopSpeed 
			XS:+ (XS/CurrentSpeed)*(TopSpeed - CurrentSpeed)
			YS:+ (YS/CurrentSpeed)*(TopSpeed - CurrentSpeed)
		EndIf
		
		X:+ XS 
		Y:+ YS 
										
		Local distance# = Sqr((x-nx)^2+(y-ny)^2) '
		Local TargetAngle# = (ATan2(y-ny,x-nx)+180.0) Mod 360.0		
		Local difference# = Abs(TargetAngle-Direction)



		If TargetAngle < Direction				
			If difference > 180.0 TurnSpeed:+TurnAcceleration Else TurnSpeed:-TurnAcceleration
		ElseIf TargetAngle > Direction
			If difference > 180.0 TurnSpeed:-TurnAcceleration Else TurnSpeed:+TurnAcceleration
		EndIf
		
		
		If difference < 1.0 TurnSpeed = 0.0			

		If TurnSpeed >  TurnMax TurnSpeed =  TurnMax
		If TurnSpeed < -TurnMax TurnSpeed = -TurnMax
		Direction = (Direction+TurnSpeed+360) Mod 360
		
	EndMethod

End Type




Function Create_Cop:tFakeCar(x:Int, y:Int)
	
	Local c:tFakeCar = New tFakeCar
		c.done = False
		c.x = (x * 64) + 32
		c.y = (y * 64) + 32
	
	Print "created cop!  " + Carslist.count()
			
	Return c
End Function



Type TCar
	Const MAXPOWER:Float = 0.05'0.1
	Const MAXTURN:Float = 0.8'0.6
	
	field positionX# = 400
	field positionY# = 300
	
	field velocityX#
	field velocityY#
	
	field drag# = 0.97
	field angle# = 0
	
	field angularVelocity# 
	
	field angularDrag# =0.8
	
	field power# = 0'0.6
	Field turnSpeed:Float = 0.7
	
	'--------------
	Field Damage:Int = 0
	Field Bombs:Int = 0
	Field Img:Int
	Field pMap:TPixmap
	Field emitter:ParticleEmitter
	Field pRate:Float
	Field smoker:tsmoker
	
	

	Method New()
		'smoker = tSmoker.Create(positionX, positionY)
	End Method
	
	Method update_Collision()
		Local x:Int, y:Int
		Local c:Int
		Local p:Byte Ptr = Varptr c
		x = (Int(positionX) / 64) '/ tRoadMap.W
		y = (Int(positionY) / 64) '/ tRoadMap.H
		If RoadMapImg[x, y] Then
			pMap = RoadMapImg[x, y].pixmaps[0]
			'
		Else
			'do game ending explotion!
			Do_Lose()
			RuntimeError("Cheats!")
		EndIf
		Assert pMap <> Null
		
		c = pMap.ReadPixel(Int(positionX) Mod 64, Int(positionY) Mod 64)
		'Print Hex(c)
		If c = $FFB97A57 Then
			velocityX = -(velocityX / 2)
			velocityY = -(velocityY / 2)
			UpdatePhysics
		ElseIf c = $FFFFFFFF Then
			 velocityX:*0.9
			 velocityY:*0.9
		EndIf
		If Damage > 50 And smoker = Null Then smoker = tSmoker.Create(positionX, positionY)
		If Damage > 100 Then Do_Lose()
		
	End Method
	
	Method ControlViaKeys()
		If KeyDown(KEY_UP) Then 
			power:+0.001
			If power > MAXPOWER Then power = MAXPOWER
			velocityX :+ Sin(angle) * power;
			velocityY :+ Cos(angle) * power;
		ElseIf KeyDown(KEY_DOWN) Then
			power:-0.001
			If power < - MAXPOWER Then power = -MAXPOWER
			velocityX :+ Sin(angle) * power;
			velocityY :+ Cos(angle) * power;
			'velocityX :* 0.9		
			'velocityY :* 0.9
			
		Else
			power :* 0.7 
		Endif
		
		'If KeyDown(KEY_DOWN) Then 
		'	velocityX :* 0.9		
		'	velocityY :* 0.9
		'Endif
		
		If KeyDown(KEY_LEFT) Then 
			angularVelocity :+ turnSpeed 
		Endif
		
		If KeyDown(KEY_RIGHT) Then 
			angularVelocity:-turnSpeed
		EndIf

	End Method 
	
	Method UpdatePhysics()
		positionX :+ velocityX
		positionY :+ velocityY
		velocityX :* drag
		velocityY :* drag
		angle :+ angularVelocity
		angularVelocity :* angularDrag
		
		
		
		turnSpeed =  Max(Abs(velocityX),Abs(velocityY))/2
		turnSpeed = Min(MAXTURN, turnSpeed)
		
		offX:-velocityX
		offY:-velocityY
	
		'// cop spawn shouldnt be here..
		If Rand(1, 100) <= CopChance Then
			Local tx:Int, ty:Int
			tx = positionX + (Sin(angle) * 128)
			ty = positionY + (Cos(angle) * 128)
			
			tx:/64
			ty:/64
			If RoadMapImg[tx, ty] <> Null Then
				Carslist.AddLast(Create_Cop(tx, ty))
			EndIf
		EndIf
		
		'// exit cond should not be here!!!
		If Dist(Player.positionX, Player.positionY, (endloc.x * 64) + 32, (endloc.y * 64) + 32) < 16 Then
			Do_Win()
		EndIf
		
		
		pRate = 1 + (Abs(power / MAXPOWER) * 2) 'interpolate_cosine(0, MAXPOWER, power)
		
	End Method
	
	Method Draw()
		SetOrigin offX, offY
		SetColor 0, 0, 0
		SetAlpha 0.5
		SetRotation 180 - angle
		DrawImage CarImg, positionX + 1, positionY + 1
		SetColor 255, 255, 255
		SetAlpha 1
		DrawImage(CarImg, positionX, positionY, Img)
		
		SetRotation 0
		SetAlpha 1
		
		
		
		'// draw rc
		
		'''DrawLine(positionX, positionY, tx, ty)
		If smoker Then
			smoker.update(positionX, positionY)
			smoker.Draw
		EndIf
		
		SetOrigin 0, 0
	End Method
	
	Method Update_AI()
		Local x1:Float, y1:Float, x2:Float, y2:Float
		x1 = Int(Player.positionX)
		y1 = Int(Player.positionY)
		
		x2 = Int(Self.positionX)
		y2 = Int(Self.positionY)
		
	'	If Dist(x1, y1, x2, y2) < 64 * 2 Then
			Local a1:Float = Self.angle
			Local a2:Float = angleto(Self.positionX, Self.positionY, Player.positionX, Player.positionY)
			Self.angle = a2'ATan2(y2 - y1, x2 - x1)  'a2':+rotarydir(a1, a2, 0.0001)'TurnDirection(a1, a2)
			
			
	'	End If
		
	End Method
EndType