

Global RoadMapImg:TImage[tRoadMap.W, tRoadmap.H]
Global RoadMapName:String[tRoadMap.W, tRoadmap.H]
Global ImageList:THashTable
Global MiniMap:TImage


Global startloc:tPoint
Global endloc:tPoint



Function MakeMap()
	tRoadMap.MakeMap
	tRoadMap.makepoints
	TPathfinder.SetUp(tRoadMap.map, 0)
	
	tRoadMap.MakePaths()
	
	'tRoadMap.Finalize_map
	
	tRoadMap.LoadImageGrid
	
	
	startloc = New tPoint
	endloc = New tPoint
	
	Select Rand(1, 4)
		Case 1
			startloc.x = 4
			startloc.y = 4
			endloc.x = tRoadMap.W - 4
			endloc.y = tRoadMap.H - 4
		Case 2
			startloc.x = tRoadMap.W - 4
			startloc.y = 4
			endloc.x = 4
			endloc.y = tRoadMap.H - 4
		Case 3
			startloc.x = 4
			startloc.y = tRoadMap.W - 4
			endloc.x = tRoadMap.W - 4
			endloc.y = 4
		Case 4
			startloc.x = tRoadMap.W - 4
			startloc.y = tRoadMap.h - 4
			endloc.x = 4
			endloc.y = 4
	End Select

End Function

Function MakeMiniMap()
	Local pMiniMap:TPixmap = CreatePixmap(tRoadMap.W, tRoadMap.H, 4)
	For Local x:Int = 0 Until tRoadMap.W
		For Local y:Int = 0 Until tRoadMap.h
			If tRoadMap.map[x, y] > 0 Then
				pMiniMap.WritePixel(x, y, $FFFFFFFF)
			Else
				pMiniMap.WritePixel(x, y, $FF000000)
			EndIf
		Next
	Next
	
	MiniMap = LoadImage(pMiniMap, 0)
End Function

Type tRoadMap
	Const W:Int = 40'*2
	Const H:Int = 40'*2
	
	
	Const r1:Int = 1
	Const r2:Int = 2
	Const r3:Int = 4
	Const r4:Int = 8
	

	Const NUMPOINTS:Int = (W * H) / 60
	
	Global Points:tpoint[]
	Global map:Float[w, h]
	Global paths:TList = CreateList()
	
	
	Function LoadImageGrid()
		Local snum:String
		Local img:TImage
		For Local x:Int = 1 Until W - 1
			For Local y:Int = 1 Until H - 1
				snum = ""
				If map[x, y] = 0 Then
					If map[x, y - 1] = 0 Then snum:+"1"
					If map[x + 1, y] = 0 Then snum:+"2"
					If map[x, y + 1] = 0 Then snum:+"3"
					If map[x - 1, y] = 0 Then snum:+"4"
				End If
				
				If snum = "" Then Continue
				
				Print snum
				
				img = TImage(ImageList.ValueForKey("r" + snum + ".png"))
			
				If Not img Then
					RuntimeError("missing image: " + "r" + snum + ".png")
				EndIf
				
				RoadMapImg[x, y] = img
				
				RoadMapName[x, y] = snum
				
			Next
		Next
		
		Print "Done with map!"
	End Function
	'--------------------------------------------------------------------------------	
	Function Finalize_map()
		For Local x:Int = 0 Until W
			For Local y:Int = 0 Until h
				If map[x, y] > 0 Then map[x, y] = 1
			Next
		Next
	End Function
	'--------------------------------------------------------------------------------
	Function MakePaths()
		For Local a% = 0 Until points.length
			Print a
			For Local b% = a+1 Until points.length
				'Print a + " " + b
				If TPathfinder.FindPath(points[a].x,points[a].y,   points[b].x,points[b].y) Then 
					'Print "found route  " + tPathfinder.Route.length
					copyroute()
				EndIf
			Next
		Next
	End Function 
	'--------------------------------------------------------------------------------
	Function CopyRoute()
		For Local i% = 0 Until tPathfinder.Route.length Step 2
			map[tPathfinder.Route[i],tPathfinder.Route[i+1]] = 0.0
		Next
		'Local r%[] = tPathfinder.Route[..]
		'Print "copied rroute with len " + r.length
		'paths.addlast(r)
	End Function
	
	'--------------------------------------------------------------------------------
	Function MakeMap()
		For Local x% = 0 Until w
			For Local y% = 0 Until h
				map[x,y] = Rnd(0.3,0.9)'0.08 + Min(Rnd(0.8),Rnd(0.8))'Rnd(0.1,0.8)
				'If  map[x,y] = 0.0 Then map[x,y] = 0.33
			Next
		Next	
	End Function
	'--------------------------------------------------------------------------------
	Function MakePoints()
		Local x%,y%
		Local p:tpoint
		
		Const G% = 4
		
		p = New tpoint
		p.x=4
		p.y=4
		points :+ [p]
		
		p = New tpoint
		p.x=w-4
		p.y=h-4
		points :+ [p]
		
		p = New tpoint
		p.x=4
		p.y=h-4
		points :+ [p]
		
		p = New tpoint
		p.x=w-4
		p.y=4
		points :+ [p]
	
		
		
		For Local i% = 0 Until NUMPOINTS
		
			x = (Rand(G,w-G)/G)*G
			y = (Rand(G,h-G)/G)*G
			
			'x = (Rand(10,w-10))
			'y = (Rand(10,h-10))
	
			
			
			If points.length < 1 Then  
				p = New tpoint
				p.x=x
				p.y=y
				points :+ [p]
				Print "made point 1"
				Continue
			EndIf
	
				p = New tPoint
				p.x=x
				p.y=y
	
				If Not checkpoint(p) Then
					points :+ [p]
					Print "made point " + points.length
				EndIf

		
		Next
				Function checkPoint%(np:tpoint)
					For Local op:tpoint = EachIn points
						If np.x = op.x And np.y = op.y Then Return True
					Next
					Return False
				End Function
	End Function
	
	
End Type

Type tPoint
	Field x%,y%
EndType

'-------------------------------------------------------------------------------------------------------------------------
Function LoadImages()
	Local img:TImage
	Local path:String = CurrentDir() + "/img/"
	
	ImageList = New THashTable
	
	Print(CurrentDir() + "/img/")
	
	Local dir:Int = ReadDir(path)

	If Not dir RuntimeError "couldnt find image dir"
	
	Repeat
		Local t:String = NextFile(dir)
		If t="" Exit
		If t="." Or t=".." Continue
		DebugLog t
		
		If Right(Lower(t), 4) = ".png" Then
			img = LoadImage(path + "/" + t, 0)
			ImageList.Insert(Lower(t), img)

		EndIf
		
	Forever
	
	CloseDir dir
	
End Function
'-------------------------------------------------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
Function Dist#(x1#,y1#,x2#,y2#)
	Return Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))) 
End Function
'--------------------------------------------------------------------------------

Function AngleTO#(X1:Float,Y1:Float,X2:Float,Y2:Float)
         Local dx# = x2 - x1
         Local dy# = y2 - y1
         'Return WrapAngle(((ATan2(dy#,dx#)+360)+90) Mod 360)
		 Return WrapAngle((ATan2(dy:Float, dx:Float)))
End Function
'--------------------------------------------------------------------------------
Function WrapAngle#(angle#)
	If angle > 0 Then
		While (angle >= 360.0)
			angle:-360.0
		Wend
	ElseIf angle < 0 Then
		While(angle < 0)
			angle:+360.0
		Wend
	'	angle = 360 + angle
	End If
	Return angle 'Mod 360

End Function
'--------------------------------------------------------------------------------
Function TurnDirection:Float(a:Float, b:Float)
	Return Abs(Min((b - a), 180.0 * Sgn(b - a))) <> 180.0
End Function
'--------------------------------------------------------------------------------
Function rotarydir:Float(Asource:Float, Adest:Float, smooth:Float = 1)
	Local diff1:Float, diff2:Float, dir:Float
	
	If Asource#>Adest#
		Diff1#=Asource-Adest
		diff2#=(360.0-Asource)+Adest
		If diff2<diff1
			dir#=diff2/smooth
		Else
			dir#=diff1/smooth*-1
		EndIf
	Else
		If Asource#<Adest#
			diff1=Adest-Asource
			diff2=(360.0-Adest)+Asource
			If diff2<diff1
				dir#=diff2/smooth*-1
			Else
				dir#=diff1/smooth
			EndIf
		Else
			dir=0
		EndIf
	EndIf
	Return dir
End Function	
'--------------------------------------------------------------------------------
'''''''''''''''''''''''''
'A General A* Pathfinder'
'Coded by Curtastic 2007'
'Coded in Lightning IDE.'
'''''''''''''''''''''''''
''SuperStrict

Type TPathfinder Abstract
	Global Used:Int = False
	'0=no diagonal movement.
	'1=diagonal movement and cutting corners allowed.
	'2=diagonal movement but no cutting corners.
	Global Diagonals:Int
	
	'The higher this number, the more the path will randomly differ from what is optimum.
	Global Randomity:Float
	
	'Map is a float. The closer to 1 the harder it is to move into this tile.
	'All values 1 or greater are considered walls.
	Global Map:Float[, ]
	Global MapWidth:Int
	Global MapHeight:Int
	
	'The amount of steps in the route. (Read only)
	Global Paths:Int
	
	'The resulting path is a 'resliced' route[].
	' as [x0, y0, x1, y1, x2, y2, x3, y3, ..etc. .. xn,yn]
	' The size of this array is paths*2.
	Global Route:Int[]
	
	'The higher the BasicCost, the more accurate and slow pathfinding will be.
	Const BasicCost:Float =  .25'.17
	'Global BasicCost:Float =.17
	
	
'Private:
	Global PathMap:TPath[, ]
	Const Root2:Float = 1.4142
	
	Function SetUp(MapPassed:Float[,], Diag:Int = 1, Random:Float = 0.0001)
		Assert Random>0, "Randomity must be positive."
		Assert Diag = 0 Or Diag = 1 Or Diag = 2, "Diagonals must be 0 or 1 or 2."
		Assert MapPassed <> Null, "Map must not be null."
		
		Map = MapPassed
		MapWidth = MapPassed.Dimensions()[0]
		MapHeight = MapPassed.Dimensions()[1]
		Diagonals = Diag
		Randomity = Random
		
	EndFunction
	
	'Returns 1 if successful and 0 if unseccessful.
	'Fills the route[] array if successful.
	Function FindPath:Int(StartX:Int, StartY:Int, EndX:Int, EndY:Int)
		
		Local T:Int = MilliSecs()
		
		Assert Not(StartX < 0 Or StartY < 0 Or StartX >= MapWidth Or StartY >= MapHeight), ..
		 "Starting point out of bounds: " + StartX + "," + StartY
		Assert Not(EndX < 0 Or EndY < 0 Or EndX >= MapWidth Or EndY >= MapHeight), ..
		 "End point out of bounds: " + EndX + "," + EndY
		Assert Map <> Null, ..
		 "SetUp() must be called before FindPath"
		
		'If already on target.
		If StartX = EndX And StartY = EndY Then
			Route = New Int[2]
			Route[0] = StartX
			Route[1] = StartY
			Paths = 1
			Return 1
		EndIf
		
		Paths = 0
		
		'If target is a wall.
		If Map[EndX, EndY] >= 1 Then Return 0
		
		
		Local P:TPath
		Local P2:TPath
		Local NewP:TPath
		Local NewX:Int
		Local NewY:Int
		Local Dir:Int
		Local DirMax:Int
		Local Done:Int
		Local PHead:TPath
		Local MapHere:Float
		Local DistX:Int
		Local DistY:Int
		
		PathMap = New TPath[MapWidth, MapHeight]
		
		'Make first path node at start.
		P = New TPath
		PHead = P
		P.X = StartX
		P.Y = StartY
		PathMap[StartX, StartY] = P
		
		If Diagonals Then
			DirMax = 7
		Else
			DirMax = 3
		EndIf
		
		
		Repeat
			
			
			For Dir = 0 To DirMax
				
				'Move based on direction.
				Select Dir
					Case 0; NewX = P.X + 1; NewY = P.Y
					Case 1; NewX = P.X    ; NewY = P.Y + 1
					Case 2; NewX = P.X - 1; NewY = P.Y
					Case 3; NewX = P.X    ; NewY = P.Y - 1
					Case 4; NewX = P.X + 1; NewY = P.Y + 1
					Case 5; NewX = P.X - 1; NewY = P.Y + 1
					Case 6; NewX = P.X - 1; NewY = P.Y - 1
					Case 7; NewX = P.X + 1; NewY = P.Y - 1
				EndSelect
				
				'Check if it is ok to make a new path node here.
				If NewX >= 0 And NewY >= 0 And NewX < MapWidth And NewY < MapHeight Then
					MapHere = Map[NewX, NewY]
					If MapHere < 1 Then
						
						'No cutting corners.
						If Diagonals = 2 And Dir > 3 Then
							If Map[NewX, P.Y] >= 1 Then Continue
							If Map[P.X, NewY] >= 1 Then Continue
						EndIf
						
						P2 = PathMap[NewX, NewY]
						
						'Check if there already is a path here.
						If P2 = Null Then
							
							'DrawRect newx*29,newy*29,29,29
							'Flip False
							'If KeyHit(key_escape) Then End
							
							'Make new node.
							NewP = New TPath
							PathMap[NewX, NewY] = NewP
							NewP.Parent = P
							NewP.X = NewX
							NewP.Y = NewY
							
							'Cost is slightly more for diagnols.
							If Dir < 4 Then
								NewP.Cost = P.Cost + BasicCost + MapHere + Rnd(0, Randomity)
							Else
								NewP.Cost = P.Cost + (BasicCost + MapHere + Rnd(0, Randomity)) * Root2
							EndIf
							
							'Calculate distance from this node to target.
							If Diagonals Then
								DistX = Abs(NewX - EndX)
								DistY = Abs(NewY - EndY)
								If DistX > DistY Then
									NewP.Dist = DistX - DistY + DistY * Root2
								Else
									NewP.Dist = DistY - DistX + DistX * Root2
								EndIf
								NewP.Dist :* .1
							Else
								NewP.Dist = (Abs(NewX - EndX) + Abs(NewY - EndY)) / 8.0
							EndIf
							
							'Insert node at appropriate spot in list.
							P2 = P
							Repeat
								If P2.After = Null Then
									P2.After = NewP
									Exit
								EndIf
								If P2.After.Dist + P2.After.Cost > NewP.Dist + NewP.Cost Then
									NewP.After = P2.After
									P2.After = NewP
									Exit
								EndIf
								P2 = P2.After
							Forever
							
							'Check if found the end.
							If NewX = EndX And NewY = EndY Then
								Done = 1
								Exit
							EndIf
						Else
							'Overwrite existing path node if this way costs less.
							If P2.Cost > P.Cost + BasicCost + MapHere * Root2 + Randomity Then
								P2.Parent = P
								'Cost is slightly more for diagnols.
								If Dir < 4 Then
									P2.Cost = P.Cost + BasicCost + MapHere + Rnd(0, Randomity)
								Else
									P2.Cost = P.Cost + (BasicCost + MapHere + Rnd(0, Randomity)) * Root2
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			Next
			
			If Done = 1 Then Exit
			
			P = P.After
			If P = Null Then Exit
			
			'If MilliSecs() - t > 10 Then
			'	Exit
			'End If
			
		Forever
		
		
		If Done Then
			'Count how many paths.
			P2 = NewP
			Repeat
				Paths:+ 1
				P2 = P2.Parent
				If P2 = Null Then Exit
				'If KeyDown(key_space) Then DebugStop
			Forever
			
			'Make route from end to start.
			Route = New Int[Paths * 2]
			Local i:Int = 0
			P2 = NewP
			Repeat
				Route[i] = P2.X
				i:+ 1
				Route[i] = P2.Y
				i:+ 1
				P2 = P2.Parent
				If P2 = Null Then Exit
			Forever
		EndIf
		
		'Nullify parent pointers so mem will be deallocated.
		P = PHead
		Repeat
			P.Parent = Null
			P = P.After
			If P = Null Then Exit
		Forever
		
		Return Done
	EndFunction
	
	'Function TestCost(val:Float)
	'	BasicCost = val
	'End Function
	
EndType


'Private
Type TPath
	Field X:Int
	Field Y:Int
	Field Parent:TPath
	Field Cost:Float
	Field Dist:Float
	Field After:TPath
EndType

